/**************************************************************************
***
***    Copyright (c) 1995-1997 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA,
***    and by the Regents of the University of California.
***    All rights reserved.
***
***    No portion of this file may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/

#include <ABKCommon/abkcommon.h>
#include <DB/DB.h>
#include "RBPlaceFromDB.h"
#include <RBPlace/pinLocCalc.h>

int main(int argc, const char *argv[])
{
  StringParam auxFileName("f",argc,argv);
  StringParam saveAsNodes   ("saveAsNodes",argc,argv);
  abkfatal(auxFileName.found(),"Usage: prog -f filename.aux");

  BoolParam check("checkDB",argc,argv);
  DB::Parameters dbParams;
  dbParams.alwaysCheckConsistency = check;

  DB db(auxFileName,dbParams);

  cout<<" Building RBPlacement"<<endl;

  RBPlacement::Parameters rbParams(argc,argv);
  RBPlaceFromDB rbp(db, rbParams);

  cout << " Row-based placement ";
  if (rbp.isConsistent()) cout << "consistent " << endl;
  else cout << "inconsistent " << endl;

  cout<<"c-c HPWL: "<<rbp.evalHPWL()<<endl;
  cout<<"p-p HPWL: "<<rbp.evalHPWL(true)<<endl;

  if(saveAsNodes.found())
      rbp.saveAsNodesNetsWts(saveAsNodes);

  return 0;
}
